/**
 * freesewing | v0.22.0
 * A library for creating made-to-measure sewing patterns
 * (c) 2018 Joost De Cock <joost@decock.org> (https://github.com/joostdecock)
 * @license MIT
 */
var freesewing=function(t){"use strict";function r(){this.list={}}function e(t,e){this.x=O(t),this.y=O(e),this.attributes=new r}function i(t,r){return t(r={exports:{}},r.exports),r.exports}t=t&&t.hasOwnProperty("default")?t.default:t,r.prototype.add=function(t,r){return void 0===this.list[t]&&(this.list[t]=[]),this.list[t].push(r),this},r.prototype.set=function(t,r){return this.list[t]=[r],this},r.prototype.remove=function(t){return delete this.list[t],this},r.prototype.get=function(t){return void 0!==this.list[t]&&this.list[t].join(" ")},r.prototype.getAsArray=function(t){return void 0!==this.list[t]&&this.list[t]},r.prototype.render=function(){var t="";for(var r in this.list)t+=" "+r+'="'+this.list[r].join(" ")+'"';return t},r.prototype.renderAsCss=function(){var t="";for(var r in this.list)t+=" "+r+":"+this.list[r].join(" ")+";";return t},r.prototype.renderIfPrefixIs=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"",r="",e=t.length;for(var i in this.list)i.substr(0,e)===t&&(r+=" "+i.substr(e)+'="'+this.list[i].join(" ")+'"');return r},r.prototype.clone=function(){var t=new r;return t.list=JSON.parse(JSON.stringify(this.list)),t},e.prototype.rad2deg=function(t){return 57.29577951308232*t},e.prototype.deg2rad=function(t){return t/57.29577951308232},e.prototype.attr=function(t,r){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,r):this.attributes.add(t,r),this},e.prototype.dist=function(t){var r=this.x-t.x,e=this.y-t.y;return O(Math.sqrt(Math.pow(r,2)+Math.pow(e,2)))},e.prototype.slope=function(t){return(t.y-this.y)/(t.x-this.x)},e.prototype.dx=function(t){return t.x-this.x},e.prototype.dy=function(t){return t.y-this.y},e.prototype.angle=function(t){for(var r=Math.atan2(-1*this.dy(t),this.dx(t));r<0;)r+=2*Math.PI;return this.rad2deg(r)},e.prototype.rotate=function(t,r){var i=this.dist(r),n=this.angle(r);return new e(r.x+i*Math.cos(this.deg2rad(n+t))*-1,r.y+i*Math.sin(this.deg2rad(n+t)))},e.prototype.copy=function(){return new e(this.x,this.y)},e.prototype.flipX=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new e(!1===t?-1*this.x:t.x+this.dx(t),this.y)},e.prototype.flipY=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return new e(this.x,!1===t?-1*this.y:t.y+this.dy(t))},e.prototype.shift=function(t,r){var e=this.copy();return e.x+=r,e.rotate(t,this)},e.prototype.shiftTowards=function(t,r){return this.shift(this.angle(t),r)},e.prototype.sitsOn=function(t){return this.x===t.x&&this.y===t.y},e.prototype.sitsRoughlyOn=function(t){return Math.round(this.x)===Math.round(t.x)&&Math.round(this.y)===Math.round(t.y)},e.prototype.shiftFractionTowards=function(t,r){return this.shiftTowards(t,this.dist(t)*r)},e.prototype.shiftOutwards=function(t,r){return this.shiftTowards(t,this.dist(t)+r)},e.prototype.clone=function(){var t=new e(this.x,this.y);return t.attributes=this.attributes.clone(),t},e.prototype.translate=function(t,r){var e=this.copy();return e.x+=t,e.y+=r,e};var n=i(function(t){var r,e,i,n,o,s,a,h,p,f,y,c,l,d;r=Math.abs,e=Math.cos,i=Math.sin,n=Math.acos,o=Math.atan2,s=Math.sqrt,a=Math.pow,h=function(t){return t<0?-a(-t,1/3):a(t,1/3)},p=Math.PI,f=2*p,y=p/2,c=Number.MAX_SAFE_INTEGER||9007199254740991,l=Number.MIN_SAFE_INTEGER||-9007199254740991,d={Tvalues:[-.06405689286260563,.06405689286260563,-.1911188674736163,.1911188674736163,-.3150426796961634,.3150426796961634,-.4337935076260451,.4337935076260451,-.5454214713888396,.5454214713888396,-.6480936519369755,.6480936519369755,-.7401241915785544,.7401241915785544,-.820001985973903,.820001985973903,-.8864155270044011,.8864155270044011,-.9382745520027328,.9382745520027328,-.9747285559713095,.9747285559713095,-.9951872199970213,.9951872199970213],Cvalues:[.12793819534675216,.12793819534675216,.1258374563468283,.1258374563468283,.12167047292780339,.12167047292780339,.1155056680537256,.1155056680537256,.10744427011596563,.10744427011596563,.09761865210411388,.09761865210411388,.08619016153195327,.08619016153195327,.0733464814110803,.0733464814110803,.05929858491543678,.05929858491543678,.04427743881741981,.04427743881741981,.028531388628933663,.028531388628933663,.0123412297999872,.0123412297999872],arcfn:function(t,r){var e=r(t),i=e.x*e.x+e.y*e.y;return void 0!==e.z&&(i+=e.z*e.z),s(i)},between:function(t,r,e){return r<=t&&t<=e||d.approximately(t,r)||d.approximately(t,e)},approximately:function(t,e,i){return r(t-e)<=(i||1e-6)},length:function(t){var r,e,i=0,n=d.Tvalues.length;for(r=0;r<n;r++)e=.5*d.Tvalues[r]+.5,i+=d.Cvalues[r]*d.arcfn(e,t);return.5*i},map:function(t,r,e,i,n){return i+(n-i)*((t-r)/(e-r))},lerp:function(t,r,e){var i={x:r.x+t*(e.x-r.x),y:r.y+t*(e.y-r.y)};return r.z&&e.z&&(i.z=r.z+t*(e.z-r.z)),i},pointToString:function(t){var r=t.x+"/"+t.y;return void 0!==t.z&&(r+="/"+t.z),r},pointsToString:function(t){return"["+t.map(d.pointToString).join(", ")+"]"},copy:function(t){return JSON.parse(JSON.stringify(t))},angle:function(t,r,e){var i=r.x-t.x,n=r.y-t.y,s=e.x-t.x,a=e.y-t.y;return o(i*a-n*s,i*s+n*a)},round:function(t,r){var e=""+t,i=e.indexOf(".");return parseFloat(e.substring(0,i+1+r))},dist:function(t,r){var e=t.x-r.x,i=t.y-r.y;return s(e*e+i*i)},closest:function(t,r){var e,i,n=a(2,63);return t.forEach(function(t,o){(i=d.dist(r,t))<n&&(n=i,e=o)}),{mdist:n,mpos:e}},abcratio:function(t,e){if(2!==e&&3!==e)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var i=a(t,e)+a(1-t,e);return r((i-1)/i)},projectionratio:function(t,r){if(2!==r&&3!==r)return!1;if(void 0===t)t=.5;else if(0===t||1===t)return t;var e=a(1-t,r);return e/(a(t,r)+e)},lli8:function(t,r,e,i,n,o,s,a){var h=(t-e)*(o-a)-(r-i)*(n-s);return 0!=h&&{x:((t*i-r*e)*(n-s)-(t-e)*(n*a-o*s))/h,y:((t*i-r*e)*(o-a)-(r-i)*(n*a-o*s))/h}},lli4:function(t,r,e,i){var n=t.x,o=t.y,s=r.x,a=r.y,h=e.x,p=e.y,u=i.x,f=i.y;return d.lli8(n,o,s,a,h,p,u,f)},lli:function(t,r){return d.lli4(t,t.c,r,r.c)},makeline:function(t,r){var e=u,i=t.x,n=t.y,o=r.x,s=r.y,a=(o-i)/3,h=(s-n)/3;return new e(i,n,i+a,n+h,i+2*a,n+2*h,o,s)},findbbox:function(t){var r=c,e=c,i=l,n=l;return t.forEach(function(t){var o=t.bbox();r>o.x.min&&(r=o.x.min),e>o.y.min&&(e=o.y.min),i<o.x.max&&(i=o.x.max),n<o.y.max&&(n=o.y.max)}),{x:{min:r,mid:(r+i)/2,max:i,size:i-r},y:{min:e,mid:(e+n)/2,max:n,size:n-e}}},shapeintersections:function(t,r,e,i,n){if(!d.bboxoverlap(r,i))return[];var o=[],s=[t.startcap,t.forward,t.back,t.endcap],a=[e.startcap,e.forward,e.back,e.endcap];return s.forEach(function(r){r.virtual||a.forEach(function(i){if(!i.virtual){var s=r.intersects(i,n);s.length>0&&(s.c1=r,s.c2=i,s.s1=t,s.s2=e,o.push(s))}})}),o},makeshape:function(t,r,e){var i=r.points.length,n=t.points.length,o=d.makeline(r.points[i-1],t.points[0]),s=d.makeline(t.points[n-1],r.points[0]),a={startcap:o,forward:t,back:r,endcap:s,bbox:d.findbbox([o,t,r,s])},h=d;return a.intersections=function(t){return h.shapeintersections(a,a.bbox,t,t.bbox,e)},a},getminmax:function(t,r,e){if(!e)return{min:0,max:0};var i,n,o=c,s=l;-1===e.indexOf(0)&&(e=[0].concat(e)),-1===e.indexOf(1)&&e.push(1);for(var a=0,h=e.length;a<h;a++)i=e[a],(n=t.get(i))[r]<o&&(o=n[r]),n[r]>s&&(s=n[r]);return{min:o,mid:(o+s)/2,max:s,size:s-o}},align:function(t,r){var n=r.p1.x,s=r.p1.y,a=-o(r.p2.y-s,r.p2.x-n);return t.map(function(t){return{x:(t.x-n)*e(a)-(t.y-s)*i(a),y:(t.x-n)*i(a)+(t.y-s)*e(a)}})},roots:function(t,r){r=r||{p1:{x:0,y:0},p2:{x:1,y:0}};var i=t.length-1,o=d.align(t,r),a=function(t){return 0<=t&&t<=1};if(2===i){if(0!==(v=(x=o[0].y)-2*(g=o[1].y)+(m=o[2].y))){var p=-s(g*g-x*m),u=-x+g;return[-(p+u)/v,-(-p+u)/v].filter(a)}return g!==m&&0===v?[(2*g-m)/2*(g-m)].filter(a):[]}var y=o[0].y,c=o[1].y,l=o[2].y,v=3*c-y-3*l+o[3].y,x=3*y-6*c+3*l,g=-3*y+3*c,m=y;if(d.approximately(v,0)){if(d.approximately(x,0))return d.approximately(g,0)?[]:[-m/g].filter(a);var w=2*x;return[((b=s(g*g-4*x*m))-g)/w,(-g-b)/w].filter(a)}var b,z,S=(o=(3*(g/=v)-(x/=v)*x)/3)/3,O=(b=(2*x*x*x-9*x*g+27*(m/=v))/27)/2,_=O*O+S*S*S;if(_<0){var M=-o/3,k=s(M*M*M),P=-b/(2*k),R=n(P<-1?-1:P>1?1:P),L=2*h(k);return[L*e(R/3)-x/3,L*e((R+f)/3)-x/3,L*e((R+2*f)/3)-x/3].filter(a)}if(0===_)return[2*(z=O<0?h(-O):-h(O))-x/3,-z-x/3].filter(a);var j=s(_);return[(z=h(-O+j))-h(O+j)-x/3].filter(a)},droots:function(t){if(3===t.length){var r=t[0],e=t[1],i=t[2],n=r-2*e+i;if(0!==n){var o=-s(e*e-r*i),a=-r+e;return[-(o+a)/n,-(-o+a)/n]}return e!==i&&0===n?[(2*e-i)/(2*(e-i))]:[]}if(2===t.length)return(r=t[0])!==(e=t[1])?[r/(r-e)]:[]},inflections:function(t){if(t.length<4)return[];var r=d.align(t,{p1:t[0],p2:t.slice(-1)[0]}),e=r[2].x*r[1].y,i=r[3].x*r[1].y,n=r[1].x*r[2].y,o=18*(-3*e+2*i+3*n-(f=r[3].x*r[2].y)),s=18*(3*e-i-3*n),a=18*(n-e);if(d.approximately(o,0)){if(!d.approximately(s,0)){var h=-a/s;if(0<=h&&h<=1)return[h]}return[]}var p=s*s-4*o*a,u=Math.sqrt(p),f=2*o;return d.approximately(f,0)?[]:[(u-s)/f,-(s+u)/f].filter(function(t){return 0<=t&&t<=1})},bboxoverlap:function(t,e){var i,n,o,s,a,h=["x","y"],p=h.length;for(i=0;i<p;i++)if(o=t[n=h[i]].mid,s=e[n].mid,a=(t[n].size+e[n].size)/2,r(o-s)>=a)return!1;return!0},expandbox:function(t,r){r.x.min<t.x.min&&(t.x.min=r.x.min),r.y.min<t.y.min&&(t.y.min=r.y.min),r.z&&r.z.min<t.z.min&&(t.z.min=r.z.min),r.x.max>t.x.max&&(t.x.max=r.x.max),r.y.max>t.y.max&&(t.y.max=r.y.max),r.z&&r.z.max>t.z.max&&(t.z.max=r.z.max),t.x.mid=(t.x.min+t.x.max)/2,t.y.mid=(t.y.min+t.y.max)/2,t.z&&(t.z.mid=(t.z.min+t.z.max)/2),t.x.size=t.x.max-t.x.min,t.y.size=t.y.max-t.y.min,t.z&&(t.z.size=t.z.max-t.z.min)},pairiteration:function(t,r,e){var i=t.bbox(),n=r.bbox(),o=1e5,s=e||.5;if(i.x.size+i.y.size<s&&n.x.size+n.y.size<s)return[(o*(t._t1+t._t2)/2|0)/o+"/"+(o*(r._t1+r._t2)/2|0)/o];var a=t.split(.5),h=r.split(.5),p=[{left:a.left,right:h.left},{left:a.left,right:h.right},{left:a.right,right:h.right},{left:a.right,right:h.left}];p=p.filter(function(t){return d.bboxoverlap(t.left.bbox(),t.right.bbox())});var u=[];return 0===p.length?u:(p.forEach(function(t){u=u.concat(d.pairiteration(t.left,t.right,s))}),u=u.filter(function(t,r){return u.indexOf(t)===r}))},getccenter:function(t,r,n){var s,a=r.x-t.x,h=r.y-t.y,p=n.x-r.x,u=n.y-r.y,c=a*e(y)-h*i(y),l=a*i(y)+h*e(y),v=p*e(y)-u*i(y),x=p*i(y)+u*e(y),g=(t.x+r.x)/2,m=(t.y+r.y)/2,w=(r.x+n.x)/2,b=(r.y+n.y)/2,z=g+c,S=m+l,O=w+v,_=b+x,M=d.lli8(g,m,z,S,w,b,O,_),k=d.dist(M,t),P=o(t.y-M.y,t.x-M.x),R=o(r.y-M.y,r.x-M.x),L=o(n.y-M.y,n.x-M.x);return P<L?((P>R||R>L)&&(P+=f),P>L&&(s=L,L=P,P=s)):L<R&&R<P?(s=L,L=P,P=s):L+=f,M.s=P,M.e=L,M.r=k,M},numberSort:function(t,r){return t-r}},t.exports=d}),o=i(function(t){var r,e;r=n,(e=function(t){this.curves=[],this._3d=!1,t&&(this.curves=t,this._3d=this.curves[0]._3d)}).prototype={valueOf:function(){return this.toString()},toString:function(){return"["+this.curves.map(function(t){return r.pointsToString(t.points)}).join(", ")+"]"},addCurve:function(t){this.curves.push(t),this._3d=this._3d||t._3d},length:function(){return this.curves.map(function(t){return t.length()}).reduce(function(t,r){return t+r})},curve:function(t){return this.curves[t]},bbox:function(){for(var t=this.curves,e=t[0].bbox(),i=1;i<t.length;i++)r.expandbox(e,t[i].bbox());return e},offset:function(t){var r=[];return this.curves.forEach(function(e){r=r.concat(e.offset(t))}),new e(r)}},t.exports=e});var s=function(t){var r,e,i,n,o,s,a=(t=t.replace(/,/g," ").replace(/-/g," - ").replace(/-\s+/g,"-").replace(/([a-zA-Z])/g," $1 ")).replace(/([a-zA-Z])\s?/g,"|$1").split("|"),h=a.length,p=[],u=0,f=0,y=0,c=0,l=0,d=0,v=0,x=0,g="";for(r=1;r<h;r++)if(n=(i=(e=a[r]).substring(0,1)).toLowerCase(),o=(p=(p=e.replace(i,"").trim().split(" ")).filter(function(t){return""!==t}).map(parseFloat)).length,"m"===n){if(g+="M ","m"===i?(y+=p[0],c+=p[1]):(y=p[0],c=p[1]),u=y,f=c,g+=y+" "+c+" ",o>2)for(s=0;s<o;s+=2)"m"===i?(y+=p[s],c+=p[s+1]):(y=p[s],c=p[s+1]),g+=["L",y,c,""].join(" ")}else if("l"===n)for(s=0;s<o;s+=2)"l"===i?(y+=p[s],c+=p[s+1]):(y=p[s],c=p[s+1]),g+=["L",y,c,""].join(" ");else if("h"===n)for(s=0;s<o;s++)"h"===i?y+=p[s]:y=p[s],g+=["L",y,c,""].join(" ");else if("v"===n)for(s=0;s<o;s++)"v"===i?c+=p[s]:c=p[s],g+=["L",y,c,""].join(" ");else if("q"===n)for(s=0;s<o;s+=4)"q"===i?(l=y+p[s],d=c+p[s+1],y+=p[s+2],c+=p[s+3]):(l=p[s],d=p[s+1],y=p[s+2],c=p[s+3]),g+=["Q",l,d,y,c,""].join(" ");else if("t"===n)for(s=0;s<o;s+=2)l=y+(y-l),d=c+(c-d),"t"===i?(y+=p[s],c+=p[s+1]):(y=p[s],c=p[s+1]),g+=["Q",l,d,y,c,""].join(" ");else if("c"===n)for(s=0;s<o;s+=6)"c"===i?(l=y+p[s],d=c+p[s+1],v=y+p[s+2],x=c+p[s+3],y+=p[s+4],c+=p[s+5]):(l=p[s],d=p[s+1],v=p[s+2],x=p[s+3],y=p[s+4],c=p[s+5]),g+=["C",l,d,v,x,y,c,""].join(" ");else if("s"===n)for(s=0;s<o;s+=4)l=y+(y-v),d=c+(c-x),"s"===i?(v=y+p[s],x=c+p[s+1],y+=p[s+2],c+=p[s+3]):(v=p[s],x=p[s+1],y=p[s+2],c=p[s+3]),g+=["C",l,d,v,x,y,c,""].join(" ");else"z"===n&&(g+="Z ",y=u,c=f);return g.trim()},a={x:!1,y:!1};function h(t,r,e){if("Z"!==r){if("M"!==r){var i=[!1,a.x,a.y].concat(e),n=new(t.bind.apply(t,i)),o=e.slice(-2);return a={x:o[0],y:o[1]},n}a={x:e[0],y:e[1]}}}var p=function(t,r){for(var e,i,n=s(r).split(" "),o=new RegExp("[MLCQZ]",""),a=[],p={C:6,Q:4,L:2,M:2};n.length;)e=n.splice(0,1)[0],o.test(e)&&(i=h(t,e,n.splice(0,p[e]).map(parseFloat)))&&a.push(i);return new t.PolyBezier(a)},u=i(function(t){!function(){var r=Math.abs,e=Math.min,i=Math.max,s=Math.cos,a=Math.sin,h=Math.acos,u=Math.sqrt,f=Math.PI,y={x:0,y:0,z:0},c=n,l=o,d=function(t){var e=t&&t.forEach?t:[].slice.call(arguments),i=!1;if("object"==typeof e[0]){i=e.length;var n=[];e.forEach(function(t){["x","y","z"].forEach(function(r){void 0!==t[r]&&n.push(t[r])})}),e=n}var o=!1,s=e.length;if(i){if(i>4){if(1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");o=!0}}else if(6!==s&&8!==s&&9!==s&&12!==s&&1!==arguments.length)throw new Error("Only new Bezier(point[]) is accepted for 4th and higher order curves");var a=!o&&(9===s||12===s)||t&&t[0]&&void 0!==t[0].z;this._3d=a;for(var h=[],p=0,u=a?3:2;p<s;p+=u){var f={x:e[p],y:e[p+1]};a&&(f.z=e[p+2]),h.push(f)}this.order=h.length-1,this.points=h;var y=["x","y"];a&&y.push("z"),this.dims=y,this.dimlen=y.length,function(t){for(var e=t.order,i=t.points,n=c.align(i,{p1:i[0],p2:i[e]}),o=0;o<n.length;o++)if(r(n[o].y)>1e-4)return void(t._linear=!1);t._linear=!0}(this),this._t1=0,this._t2=1,this.update()},v=p;function x(t,r,e,i,n){void 0===n&&(n=.5);var o=c.projectionratio(n,t),s=1-o,a={x:o*r.x+s*i.x,y:o*r.y+s*i.y},h=c.abcratio(n,t);return{A:{x:e.x+(e.x-a.x)/h,y:e.y+(e.y-a.y)/h},B:e,C:a}}d.SVGtoBeziers=function(t){return v(d,t)},d.quadraticFromPoints=function(t,r,e,i){if(void 0===i&&(i=.5),0===i)return new d(r,r,e);if(1===i)return new d(t,r,r);var n=x(2,t,r,e,i);return new d(t,n.A,e)},d.cubicFromPoints=function(t,r,e,i,n){void 0===i&&(i=.5);var o=x(3,t,r,e,i);void 0===n&&(n=c.dist(r,o.C));var s=n*(1-i)/i,a=c.dist(t,e),h=(e.x-t.x)/a,p=(e.y-t.y)/a,u=n*h,f=n*p,y=s*h,l=s*p,v=r.x-u,g=r.y-f,m=r.x+y,w=r.y+l,b=o.A,z=b.x+(v-b.x)/(1-i),S=b.y+(g-b.y)/(1-i),O=b.x+(m-b.x)/i,_=b.y+(w-b.y)/i,M={x:t.x+(z-t.x)/i,y:t.y+(S-t.y)/i},k={x:e.x+(O-e.x)/(1-i),y:e.y+(_-e.y)/(1-i)};return new d(t,M,k,e)};var g=function(){return c};d.getUtils=g,d.PolyBezier=l,d.prototype={getUtils:g,valueOf:function(){return this.toString()},toString:function(){return c.pointsToString(this.points)},toSVG:function(t){if(this._3d)return!1;for(var r=this.points,e=["M",r[0].x,r[0].y,2===this.order?"Q":"C"],i=1,n=r.length;i<n;i++)e.push(r[i].x),e.push(r[i].y);return e.join(" ")},update:function(){this.dpoints=[];for(var t=this.points,r=t.length,e=r-1;r>1;r--,e--){for(var i,n=[],o=0;o<e;o++)i={x:e*(t[o+1].x-t[o].x),y:e*(t[o+1].y-t[o].y)},this._3d&&(i.z=e*(t[o+1].z-t[o].z)),n.push(i);this.dpoints.push(n),t=n}this.computedirection()},computedirection:function(){var t=this.points,r=c.angle(t[0],t[this.order],t[1]);this.clockwise=r>0},length:function(){return c.length(this.derivative.bind(this))},_lut:[],getLUT:function(t){if(t=t||100,this._lut.length===t)return this._lut;this._lut=[],t--;for(var r=0;r<=t;r++)this._lut.push(this.compute(r/t));return this._lut},on:function(t,r){r=r||5;for(var e,i=this.getLUT(),n=[],o=0,s=0;s<i.length;s++)e=i[s],c.dist(e,t)<r&&(n.push(e),o+=s/i.length);return!!n.length&&o/n.length},project:function(t){var r=this.getLUT(),e=r.length-1,i=c.closest(r,t),n=i.mdist,o=i.mpos;if(0===o||o===e){var s=o/e,a=this.compute(s);return a.t=s,a.d=n,a}var h,p,u,f=(o+1)/e,y=.1/e;for(n+=1,h=s=(o-1)/e;s<f+y;s+=y)p=this.compute(s),(u=c.dist(t,p))<n&&(n=u,h=s);return(p=this.compute(h)).t=h,p.d=n,p},get:function(t){return this.compute(t)},point:function(t){return this.points[t]},compute:function(t){if(0===t)return this.points[0];if(1===t)return this.points[this.order];var r=this.points,e=1-t;if(1===this.order)return p={x:e*r[0].x+t*r[1].x,y:e*r[0].y+t*r[1].y},this._3d&&(p.z=e*r[0].z+t*r[1].z),p;if(this.order<4){var i,n,o,s=e*e,a=t*t,h=0;2===this.order?(r=[r[0],r[1],r[2],y],i=s,n=e*t*2,o=a):3===this.order&&(i=s*e,n=s*t*3,o=e*a*3,h=t*a);var p={x:i*r[0].x+n*r[1].x+o*r[2].x+h*r[3].x,y:i*r[0].y+n*r[1].y+o*r[2].y+h*r[3].y};return this._3d&&(p.z=i*r[0].z+n*r[1].z+o*r[2].z+h*r[3].z),p}for(var u=JSON.parse(JSON.stringify(this.points));u.length>1;){for(var f=0;f<u.length-1;f++)u[f]={x:u[f].x+(u[f+1].x-u[f].x)*t,y:u[f].y+(u[f+1].y-u[f].y)*t},void 0!==u[f].z&&(u[f]=u[f].z+(u[f+1].z-u[f].z)*t);u.splice(u.length-1,1)}return u[0]},raise:function(){for(var t,r,e=this.points,i=[e[0]],n=e.length,o=1;o<n;o++)t=e[o],r=e[o-1],i[o]={x:(n-o)/n*t.x+o/n*r.x,y:(n-o)/n*t.y+o/n*r.y};return i[n]=e[n-1],new d(i)},derivative:function(t){var r,e,i=1-t,n=0,o=this.dpoints[0];2===this.order&&(o=[o[0],o[1],y],r=i,e=t),3===this.order&&(r=i*i,e=i*t*2,n=t*t);var s={x:r*o[0].x+e*o[1].x+n*o[2].x,y:r*o[0].y+e*o[1].y+n*o[2].y};return this._3d&&(s.z=r*o[0].z+e*o[1].z+n*o[2].z),s},inflections:function(){return c.inflections(this.points)},normal:function(t){return this._3d?this.__normal3(t):this.__normal2(t)},__normal2:function(t){var r=this.derivative(t),e=u(r.x*r.x+r.y*r.y);return{x:-r.y/e,y:r.x/e}},__normal3:function(t){var r=this.derivative(t),e=this.derivative(t+.01),i=u(r.x*r.x+r.y*r.y+r.z*r.z),n=u(e.x*e.x+e.y*e.y+e.z*e.z);r.x/=i,r.y/=i,r.z/=i,e.x/=n,e.y/=n,e.z/=n;var o={x:e.y*r.z-e.z*r.y,y:e.z*r.x-e.x*r.z,z:e.x*r.y-e.y*r.x},s=u(o.x*o.x+o.y*o.y+o.z*o.z);o.x/=s,o.y/=s,o.z/=s;var a=[o.x*o.x,o.x*o.y-o.z,o.x*o.z+o.y,o.x*o.y+o.z,o.y*o.y,o.y*o.z-o.x,o.x*o.z-o.y,o.y*o.z+o.x,o.z*o.z];return{x:a[0]*r.x+a[1]*r.y+a[2]*r.z,y:a[3]*r.x+a[4]*r.y+a[5]*r.z,z:a[6]*r.x+a[7]*r.y+a[8]*r.z}},hull:function(t){var r,e=this.points,i=[],n=[],o=0,s=0,a=0;for(n[o++]=e[0],n[o++]=e[1],n[o++]=e[2],3===this.order&&(n[o++]=e[3]);e.length>1;){for(i=[],s=0,a=e.length-1;s<a;s++)r=c.lerp(t,e[s],e[s+1]),n[o++]=r,i.push(r);e=i}return n},split:function(t,r){if(0===t&&r)return this.split(r).left;if(1===r)return this.split(t).right;var e=this.hull(t),i={left:2===this.order?new d([e[0],e[3],e[5]]):new d([e[0],e[4],e[7],e[9]]),right:2===this.order?new d([e[5],e[4],e[2]]):new d([e[9],e[8],e[6],e[3]]),span:e};return i.left._t1=c.map(0,0,1,this._t1,this._t2),i.left._t2=c.map(t,0,1,this._t1,this._t2),i.right._t1=c.map(t,0,1,this._t1,this._t2),i.right._t2=c.map(1,0,1,this._t1,this._t2),r?(r=c.map(r,t,1,0,1),i.right.split(r).left):i},extrema:function(){var t,r,e=this.dims,i={},n=[];return e.forEach(function(e){r=function(t){return t[e]},t=this.dpoints[0].map(r),i[e]=c.droots(t),3===this.order&&(t=this.dpoints[1].map(r),i[e]=i[e].concat(c.droots(t))),i[e]=i[e].filter(function(t){return t>=0&&t<=1}),n=n.concat(i[e].sort(c.numberSort))}.bind(this)),n=n.sort(c.numberSort).filter(function(t,r){return n.indexOf(t)===r}),i.values=n,i},bbox:function(){var t=this.extrema(),r={};return this.dims.forEach(function(e){r[e]=c.getminmax(this,e,t[e])}.bind(this)),r},overlaps:function(t){var r=this.bbox(),e=t.bbox();return c.bboxoverlap(r,e)},offset:function(t,r){if(void 0!==r){var e=this.get(t),i=this.normal(t),n={c:e,n:i,x:e.x+i.x*r,y:e.y+i.y*r};return this._3d&&(n.z=e.z+i.z*r),n}if(this._linear){var o=this.normal(0),s=this.points.map(function(r){var e={x:r.x+t*o.x,y:r.y+t*o.y};return r.z&&i.z&&(e.z=r.z+t*o.z),e});return[new d(s)]}return this.reduce().map(function(r){return r.scale(t)})},simple:function(){if(3===this.order){var t=c.angle(this.points[0],this.points[3],this.points[1]),e=c.angle(this.points[0],this.points[3],this.points[2]);if(t>0&&e<0||t<0&&e>0)return!1}var i=this.normal(0),n=this.normal(1),o=i.x*n.x+i.y*n.y;return this._3d&&(o+=i.z*n.z),r(h(o))<f/3},reduce:function(){var t,e,i=0,n=0,o=[],s=[],a=this.extrema().values;for(-1===a.indexOf(0)&&(a=[0].concat(a)),-1===a.indexOf(1)&&a.push(1),i=a[0],t=1;t<a.length;t++)n=a[t],(e=this.split(i,n))._t1=i,e._t2=n,o.push(e),i=n;return o.forEach(function(t){for(i=0,n=0;n<=1;)for(n=i+.01;n<=1.01;n+=.01)if(!(e=t.split(i,n)).simple()){if(r(i-(n-=.01))<.01)return[];(e=t.split(i,n))._t1=c.map(i,0,1,t._t1,t._t2),e._t2=c.map(n,0,1,t._t1,t._t2),s.push(e),i=n;break}i<1&&((e=t.split(i,1))._t1=c.map(i,0,1,t._t1,t._t2),e._t2=t._t2,s.push(e))}),s},scale:function(t){var r=this.order,e=!1;if("function"==typeof t&&(e=t),e&&2===r)return this.raise().scale(e);var i=this.clockwise,n=e?e(0):t,o=e?e(1):t,s=[this.offset(0,10),this.offset(1,10)],a=c.lli4(s[0],s[0].c,s[1],s[1].c);if(!a)throw new Error("cannot scale this curve. Try reducing it first.");var h=this.points,p=[];return[0,1].forEach(function(t){var e=p[t*r]=c.copy(h[t*r]);e.x+=(t?o:n)*s[t].n.x,e.y+=(t?o:n)*s[t].n.y}.bind(this)),e?([0,1].forEach(function(n){if(2!==this.order||!n){var o=h[n+1],s={x:o.x-a.x,y:o.y-a.y},f=e?e((n+1)/r):t;e&&!i&&(f=-f);var y=u(s.x*s.x+s.y*s.y);s.x/=y,s.y/=y,p[n+1]={x:o.x+f*s.x,y:o.y+f*s.y}}}.bind(this)),new d(p)):([0,1].forEach(function(t){if(2!==this.order||!t){var e=p[t*r],i=this.derivative(t),n={x:e.x+i.x,y:e.y+i.y};p[t+1]=c.lli4(e,n,a,h[t+1])}}.bind(this)),new d(p))},outline:function(t,r,e,i){r=void 0===r?t:r;var n,o=this.reduce(),s=o.length,a=[],h=[],p=0,u=this.length(),f=void 0!==e&&void 0!==i;function y(t,r,e,i,n){return function(o){var s=i/e,a=(i+n)/e,h=r-t;return c.map(o,0,1,t+s*h,t+a*h)}}o.forEach(function(n){z=n.length(),f?(a.push(n.scale(y(t,e,u,p,z))),h.push(n.scale(y(-r,-i,u,p,z)))):(a.push(n.scale(t)),h.push(n.scale(-r))),p+=z}),h=h.map(function(t){return(n=t.points)[3]?t.points=[n[3],n[2],n[1],n[0]]:t.points=[n[2],n[1],n[0]],t}).reverse();var d=a[0].points[0],v=a[s-1].points[a[s-1].points.length-1],x=h[s-1].points[h[s-1].points.length-1],g=h[0].points[0],m=c.makeline(x,d),w=c.makeline(v,g),b=[m].concat(a).concat([w]).concat(h),z=b.length;return new l(b)},outlineshapes:function(t,r,e){r=r||t;for(var i=this.outline(t,r).curves,n=[],o=1,s=i.length;o<s/2;o++){var a=c.makeshape(i[o],i[s-o],e);a.startcap.virtual=o>1,a.endcap.virtual=o<s/2-1,n.push(a)}return n},intersects:function(t,r){return t?t.p1&&t.p2?this.lineIntersects(t):(t instanceof d&&(t=t.reduce()),this.curveintersects(this.reduce(),t,r)):this.selfintersects(r)},lineIntersects:function(t){var r=e(t.p1.x,t.p2.x),n=e(t.p1.y,t.p2.y),o=i(t.p1.x,t.p2.x),s=i(t.p1.y,t.p2.y),a=this;return c.roots(this.points,t).filter(function(t){var e=a.get(t);return c.between(e.x,r,o)&&c.between(e.y,n,s)})},selfintersects:function(t){var r,e,i,n,o=this.reduce(),s=o.length-2,a=[];for(r=0;r<s;r++)i=o.slice(r,r+1),n=o.slice(r+2),e=this.curveintersects(i,n,t),a=a.concat(e);return a},curveintersects:function(t,r,e){var i=[];t.forEach(function(t){r.forEach(function(r){t.overlaps(r)&&i.push({left:t,right:r})})});var n=[];return i.forEach(function(t){var r=c.pairiteration(t.left,t.right,e);r.length>0&&(n=n.concat(r))}),n},arcs:function(t){t=t||.5;return this._iterate(t,[])},_error:function(t,e,i,n){var o=(n-i)/4,s=this.get(i+o),a=this.get(n-o),h=c.dist(t,e),p=c.dist(t,s),u=c.dist(t,a);return r(p-h)+r(u-h)},_iterate:function(t,r){var e,i=0,n=1;do{e=0,n=1;var o,h,p,u,f,y=this.get(i),l=!1,d=!1,v=n,x=1;do{if(d=l,u=p,v=(i+n)/2,o=this.get(v),h=this.get(n),(p=c.getccenter(y,o,h)).interval={start:i,end:n},l=this._error(p,y,i,n)<=t,(f=d&&!l)||(x=n),l){if(n>=1){if(p.interval.end=x=1,u=p,n>1){var g={x:p.x+p.r*s(p.e),y:p.y+p.r*a(p.e)};p.e+=c.angle({x:p.x,y:p.y},g,this.get(1))}break}n+=(n-i)/2}else n=v}while(!f&&e++<100);if(e>=100)break;u=u||p,r.push(u),i=x}while(n<1);return r}},t.exports=d}()}),f=u;function y(t){return t.charAt(0).toUpperCase()+t.slice(1)}function c(t){return"_macro_"+t}function l(t,r,i,n){var o=t.slope(r),s=i.slope(n);if(o===s)return!1;if(t.x===r.x)return new e(t.x,s*t.x+(i.y-s*i.x));if(i.x===n.x)return new e(i.x,o*i.x+(t.y-o*t.x));t.x>r.x&&(t=r.copy()),i.x>n.x&&(i=n.copy());var a=t.y-o*t.x,h=(i.y-s*i.x-a)/(o-s);return new e(h,o*h+a)}function d(t,r,e,i){var n=l(t,r,e,i);if(!n)return!1;var o=t.dist(r),s=e.dist(i),a=t.dist(n)+n.dist(r),h=e.dist(n)+n.dist(i);return Math.round(o)==Math.round(a)&&Math.round(s)==Math.round(h)&&n}function v(t,r,e){var i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6;if(t.sitsOn(e))return!0;if(r.sitsOn(e))return!0;var n=e.dx(t)*r.dy(t)-e.dy(t)*r.dx(t);return 0===Math.abs(Math.round(n*i)/i)}function x(t,r,e){if(!v(t,r,e,arguments.length>3&&void 0!==arguments[3]?arguments[3]:1e6))return!1;var i=t.dist(r),n=t.dist(e)+e.dist(r);return Math.round(i)==Math.round(n)}function g(t,r,e,i,n){if(t.sitsOn(n))return!0;if(i.sitsOn(n))return!0;var o=new f({x:t.x,y:t.y},{x:r.x,y:r.y},{x:e.x,y:e.y},{x:i.x,y:i.y}).intersects({p1:{x:n.x-1,y:n.y},p2:{x:n.x+1,y:n.y}});return o.length>0&&o.shift()}function m(t){return"imperial"===(arguments.length>1&&void 0!==arguments[1]?arguments[1]:"metric")?O(t/25.4)+'"':O(t/10)+"cm"}function w(t,r,i,n,o,s){var a=[],h=new f({x:i.x,y:i.y},{x:n.x,y:n.y},{x:o.x,y:o.y},{x:s.x,y:s.y}),p={p1:{x:t.x,y:t.y},p2:{x:r.x,y:r.y}},u=!0,y=!1,c=void 0;try{for(var l,d=h.intersects(p)[Symbol.iterator]();!(u=(l=d.next()).done);u=!0){var v=l.value,x=h.get(v);a.push(new e(x.x,x.y))}}catch(t){y=!0,c=t}finally{try{!u&&d.return&&d.return()}finally{if(y)throw c}}return 0!==a.length&&(1===a.length?a[0]:a)}function b(t,r,i,n,o,s,a,h){var p=[],u=new f({x:t.x,y:t.y},{x:r.x,y:r.y},{x:i.x,y:i.y},{x:n.x,y:n.y}),y=new f({x:o.x,y:o.y},{x:s.x,y:s.y},{x:a.x,y:a.y},{x:h.x,y:h.y}),c=!0,l=!1,d=void 0;try{for(var v,x=u.intersects(y,.005)[Symbol.iterator]();!(c=(v=x.next()).done);c=!0){var g=v.value,m=u.get(g.substr(0,g.indexOf("/")));p.push(new e(m.x,m.y))}}catch(t){l=!0,d=t}finally{try{!c&&x.return&&x.return()}finally{if(l)throw d}}if(0===p.length)return!1;if(1===p.length)return p.shift();var w=[],b=!0,z=!1,S=void 0;try{for(var O,_=p[Symbol.iterator]();!(b=(O=_.next()).done);b=!0){var M=O.value,k=!1,P=!0,R=!1,L=void 0;try{for(var j,I=w[Symbol.iterator]();!(P=(j=I.next()).done);P=!0){var A=j.value;M.sitsRoughlyOn(A)&&(k=!0)}}catch(t){R=!0,L=t}finally{try{!P&&I.return&&I.return()}finally{if(R)throw L}}k||w.push(M)}}catch(t){z=!0,S=t}finally{try{!b&&_.return&&_.return()}finally{if(z)throw S}}return w}function z(t,r,i,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",s=n.x-i.x,a=n.y-i.y,h=Math.pow(s,2)+Math.pow(a,2),p=2*(s*(i.x-t.x)+a*(i.y-t.y)),u=Math.pow(i.x-t.x,2)+Math.pow(i.y-t.y,2)-Math.pow(r,2),f=Math.pow(p,2)-4*h*u;if(h<=1e-7||f<0)return!1;if(0===f){var y=-1*p/(2*h);return[new e(i.x+y*s,i.y+y*a)]}var c=(-1*p+Math.sqrt(f))/(2*h),l=new e(i.x+c*s,i.y+c*a);c=(-1*p-Math.sqrt(f))/(2*h);var d=new e(i.x+c*s,i.y+c*a);return"x"===o&&l.x<=d.x||"y"===o&&l.y<=d.y?[l,d]:[d,l]}function S(t,r){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:500,n=1/0,o=1/0,s=void 0;"bottom"===r&&(o=-1/0),"right"===r&&(n=-1/0);for(var a=0;a<i;a++)s=t.get(a/i),("top"===r&&s.y<o||"bottom"===r&&s.y>o||"right"===r&&s.x>n||"left"===r&&s.x<n)&&(n=s.x,o=s.y);return new e(n,o)}function O(t){return Math.round(100*t)/100}function _(t,r){return"stroke: hsl("+330/r*(t-1)+", 100%, 35%);"}var M=Object.freeze({capitalize:y,macroName:c,beamsIntersect:l,linesIntersect:d,pointOnBeam:v,pointOnLine:x,pointOnCurve:g,beamIntersectsX:function(t,r,i){return t.x!==r.x&&l(t,r,new e(i,-10),new e(i,10))},beamIntersectsY:function(t,r,i){return t.y!==r.y&&l(t,r,new e(-10,i),new e(10,i))},units:m,lineIntersectsCurve:w,curvesIntersect:b,circlesIntersect:function(t,r,i,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",s=t.dx(i),a=t.dy(i),h=t.dist(i);if(h>parseFloat(r)+parseFloat(n))return!1;if(h<parseFloat(n)-parseFloat(r))return!1;if(0===h&&r===n)return!1;var p=(Math.pow(r,2)-Math.pow(n,2)+Math.pow(h,2))/(2*h),u=Math.sqrt(Math.pow(r,2)-Math.pow(p,2)),f=t.x+p*s/h,y=t.y+p*a/h,c=new e(f+u*a/h,y-u*s/h),l=new e(f-u*a/h,y+u*s/h);return"x"===o&&c.x<=l.x||"y"===o&&c.y<=l.y?[c,l]:[l,c]},beamIntersectsCircle:z,lineIntersectsCircle:function(t,r,e,i){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"x",o=z(t,r,e,i,n);if(!1===o)return!1;if(1===o.length)return!!x(e,i,o[0])&&o;var s=o[0],a=o[1];return!(!x(e,i,s,5)&&!x(e,i,a,5))&&(x(e,i,s,5)&&x(e,i,a,5)?"x"===n&&s.x<=a.x||"y"===n&&s.y<=a.y?[s,a]:[a,s]:x(e,i,s,5)?[s]:x(e,i,a,5)?[a]:void 0)},curveEdge:S,stretchToScale:function(t){return 1/(1+parseFloat(t))},round:O,sampleStyle:_}),k="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},P=Object.assign||function(t){for(var r=1;r<arguments.length;r++){var e=arguments[r];for(var i in e)Object.prototype.hasOwnProperty.call(e,i)&&(t[i]=e[i])}return t};function R(){this.render=!0,this.topLeft=!1,this.bottomRight=!1,this.attributes=new r,this.ops=[]}function L(t,r,e){if(t.x===r.x&&t.y===r.y)return!1;var i=t.angle(r)-90;return(new R).move(t.shift(i,e)).line(r.shift(i,e))}function j(t){return(new R).move(new e(t.points[0].x,t.points[0].y)).curve(new e(t.points[1].x,t.points[1].y),new e(t.points[2].x,t.points[2].y),new e(t.points[3].x,t.points[3].y))}function I(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1],e=(new R).move(t[0].ops[0].to),i=void 0,n=!0,o=!1,s=void 0;try{for(var a,h=t[Symbol.iterator]();!(n=(a=h.next()).done);n=!0){var p=a.value,u=!0,f=!1,y=void 0;try{for(var c,l=p.ops[Symbol.iterator]();!(u=(c=l.next()).done);u=!0){var d=c.value;if("curve"===d.type)e.curve(d.cp1,d.cp2,d.to);else{if("close"===d.type)throw"Cannot join a closed paths with another";i&&!d.to.sitsRoughlyOn(i)&&e.line(d.to)}d.to&&(i=d.to)}}catch(t){f=!0,y=t}finally{try{!u&&l.return&&l.return()}finally{if(f)throw y}}}}catch(t){o=!0,s=t}finally{try{!n&&h.return&&h.return()}finally{if(o)throw s}}return r&&e.close(),e}function A(t,r){for(var i=void 0,n=void 0,o=void 0,s=void 0,a=0,h=0;h<=100;h++){if(o=h/100,n=new e((n=r.get(o)).x,n.y),h>0){if(a+(s=n.dist(i))>t)return n;a+=s}i=n}}function T(t){var r=t.from,i=t.to;return r.x===i.x?r.y<i.y?{topLeft:r,bottomRight:i}:{topLeft:i,bottomRight:r}:r.y===i.y?r.x<i.x?{topLeft:r,bottomRight:i}:{topLeft:i,bottomRight:r}:r.x<i.x?r.y<i.y?{topLeft:r,bottomRight:i}:{topLeft:new e(r.x,i.y),bottomRight:new e(i.x,r.y)}:r.x>i.x?r.y<i.y?{topLeft:new e(i.x,r.y),bottomRight:new e(r.x,i.y)}:{topLeft:new e(i.x,i.y),bottomRight:new e(r.x,r.y)}:void 0}function C(t,r){if(t&&"object"===(void 0===t?"undefined":k(t)))if("number"==typeof t.x)r.push(t);else{var e=!0,i=!1,n=void 0;try{for(var o,s=t[Symbol.iterator]();!(e=(o=s.next()).done);e=!0){var a=o.value;r.push(a)}}catch(t){i=!0,n=t}finally{try{!e&&s.return&&s.return()}finally{if(i)throw n}}}}function E(t,e){return this.def=t,this.anchor=e,this.attributes=new r,this}function N(){return this.attributes=new r,this.points={},this.paths={},this.snippets={},this.freeId=0,this.topLeft=!1,this.bottomRight=!1,this.width=!1,this.height=!1,this.render=!0,this.utils=M,this.Point=e,this.Path=R,this.Snippet=E,this}R.prototype.move=function(t){return this.ops.push({type:"move",to:t}),this},R.prototype.line=function(t){return this.ops.push({type:"line",to:t}),this},R.prototype.curve=function(t,r,e){return this.ops.push({type:"curve",cp1:t,cp2:r,to:e}),this},R.prototype.close=function(){return this.ops.push({type:"close"}),this},R.prototype.attr=function(t,r){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,r):this.attributes.add(t,r),this},R.prototype.asPathstring=function(){var t="",r=!0,e=!1,i=void 0;try{for(var n,o=this.ops[Symbol.iterator]();!(r=(n=o.next()).done);r=!0){var s=n.value;switch(s.type){case"move":t+="M "+s.to.x+","+s.to.y;break;case"line":t+=" L "+s.to.x+","+s.to.y;break;case"curve":t+=" C "+s.cp1.x+","+s.cp1.y+" "+s.cp2.x+","+s.cp2.y+" "+s.to.x+","+s.to.y;break;case"close":t+=" z"}}}catch(t){e=!0,i=t}finally{try{!r&&o.return&&o.return()}finally{if(e)throw i}}return t},R.prototype.offset=function(t){return function(t,r){var e=[],i=void 0,n=!1;for(var o in t.ops){var s=t.ops[o];if("line"===s.type){var a=L(i,s.to,r);a&&e.push(a)}else if("curve"===s.type){var h=void 0,p=void 0;h=i.sitsRoughlyOn(s.cp1)?(new R).move(i).curve(s.cp1,s.cp2,s.to).shiftAlong(2):s.cp1,p=s.cp2.sitsRoughlyOn(s.to)?(new R).move(s.to).curve(s.cp2,s.cp1,i).shiftAlong(2):s.cp2;var u=new f({x:i.x,y:i.y},{x:h.x,y:h.y},{x:p.x,y:p.y},{x:s.to.x,y:s.to.y}),y=!0,c=!1,l=void 0;try{for(var d,v=u.offset(r)[Symbol.iterator]();!(y=(d=v.next()).done);y=!0){var x=d.value;e.push(j(x))}}catch(t){c=!0,l=t}finally{try{!y&&v.return&&v.return()}finally{if(c)throw l}}}else"close"===s.type&&(n=!0);s.to&&(i=s.to)}return I(e,n)}(this,t)},R.prototype.length=function(){var t=void 0,r=void 0,e=0;for(var i in this.ops){var n=this.ops[i];"move"===n.type?r=n.to:"line"===n.type?e+=t.dist(n.to):"curve"===n.type?e+=new f({x:t.x,y:t.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}).length():"close"===n.type&&(e+=t.dist(r)),n.to&&(t=n.to)}return O(e)},R.prototype.start=function(){return this.ops[0].to},R.prototype.end=function(){var t=this.ops[this.ops.length-1];return"close"===t.type?this.start():t.to},R.prototype.boundary=function(){if(this.topLeft)return this;var t=void 0,r=new e(1/0,1/0),i=new e(-1/0,-1/0),n=[];for(var o in this.ops){var s=this.ops[o];if("move"===s.type||"line"===s.type)s.to.x<r.x&&(r.x=s.to.x,n.leftOp=o),s.to.y<r.y&&(r.y=s.to.y,n.topOp=o),s.to.x>i.x&&(i.x=s.to.x,n.rightOp=o),s.to.y>i.y&&(i.y=s.to.y,n.bottomOp=o);else if("curve"===s.type){var a=new f({x:t.x,y:t.y},{x:s.cp1.x,y:s.cp1.y},{x:s.cp2.x,y:s.cp2.y},{x:s.to.x,y:s.to.y}).bbox();a.x.min<r.x&&(r.x=a.x.min,n.leftOp=o),a.y.min<r.y&&(r.y=a.y.min,n.topOp=o),a.x.max>i.x&&(i.x=a.x.max,n.rightOp=o),a.y.max>i.y&&(i.y=a.y.max,n.bottomOp=o)}s.to&&(t=s.to)}this.topLeft=r,this.bottomRight=i;for(var h=["top","left","bottom","right"],p=0;p<h.length;p++){var u=h[p]+"Op";this[u]=this.ops[n[u]],this[u].from="move"===this[u].type?this[u].to:this.ops[n[u]-1].to}return this},R.prototype.clone=function(){var t=new R;for(var r in t.render=this.render,this.topLeft?t.topLeft=this.topLeft.clone():t.topLeft=!1,this.bottomRight?t.bottomRight=this.bottomRight.clone():t.bottomRight=!1,t.attributes=this.attributes.clone(),t.ops=[],this.ops){var e=this.ops[r];t.ops[r]={type:e.type},"move"===e.type||"line"===e.type?t.ops[r].to=e.to.clone():"curve"===e.type&&(t.ops[r].to=e.to.clone(),t.ops[r].cp1=e.cp1.clone(),t.ops[r].cp2=e.cp2.clone())}return t},R.prototype.join=function(t){return I([this,t],arguments.length>1&&void 0!==arguments[1]&&arguments[1])},R.prototype.shiftAlong=function(t){var r=0,e=void 0;for(var i in this.ops){var n=this.ops[i];if("line"===n.type){var o=n.to.dist(e);if(r+o>t)return e.shiftTowards(n.to,t-r);r+=o}else if("curve"===n.type){var s=new f({x:e.x,y:e.y},{x:n.cp1.x,y:n.cp1.y},{x:n.cp2.x,y:n.cp2.y},{x:n.to.x,y:n.to.y}),a=s.length();if(r+a>t)return A(t-r,s);r+=a}e=n.to}throw"Ran out of path to shift along"},R.prototype.shiftFractionAlong=function(t){return this.shiftAlong(this.length()*t)},R.prototype.bbox=function(){var t,r,i=[],n=void 0;for(var o in this.ops){var s=this.ops[o];"line"===s.type?i.push(T({from:n,to:s.to})):"curve"===s.type&&i.push((t=new f({x:n.x,y:n.y},{x:s.cp1.x,y:s.cp1.y},{x:s.cp2.x,y:s.cp2.y},{x:s.to.x,y:s.to.y}),void 0,{topLeft:new e((r=t.bbox()).x.min,r.y.min),bottomRight:new e(r.x.max,r.y.max)})),s.to&&(n=s.to)}return function(t){var r=1/0,i=-1/0,n=1/0,o=-1/0,s=!0,a=!1,h=void 0;try{for(var p,u=t[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;f.topLeft.x<r&&(r=f.topLeft.x),f.topLeft.y<n&&(n=f.topLeft.y),f.bottomRight.x>i&&(i=f.bottomRight.x),f.bottomRight.y>o&&(o=f.bottomRight.y)}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return{topLeft:new e(r,n),bottomRight:new e(i,o)}}(i)},R.prototype.reverse=function(){var t=[],r=void 0,e=!1;for(var i in this.ops){var n=this.ops[i];"line"===n.type?n.to.sitsOn(r)||t.push((new R).move(n.to).line(r)):"curve"===n.type?t.push((new R).move(n.to).curve(n.cp2,n.cp1,r)):"close"===n.type&&(e=!0),n.to&&(r=n.to)}var o=(new R).move(r),s=!0,a=!1,h=void 0;try{for(var p,u=t.reverse()[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;o.ops.push(f.ops[1])}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return e&&o.close(),o},R.prototype.edge=function(t){if(this.boundary(),"topLeft"===t)return this.topLeft;if("bottomRight"===t)return this.bottomRight;if("topRight"===t)return new e(this.bottomRight.x,this.topLeft.y);if("bottomLeft"===t)return new e(this.topLeft.x,this.bottomRight.y);var r,i=t+"Op";if("move"===this[i].type)return this[i].to;if("line"===this[i].type){if("top"===t)return this.topOp.to.y<this.topOp.from.y?this.topOp.to:this.topOp.from;if("left"===t)return this.leftOp.to.x<this.leftOp.from.x?this.leftOp.to:this.leftOp.from;if("bottom"===t)return this.bottomOp.to.y>this.bottomOp.from.y?this.bottomOp.to:this.bottomOp.from;if("right"===t)return this.rightOp.to.x>this.rightOp.from.x?this.rightOp.to:this.rightOp.from}else if("curve"===this[i].type){return S((r=this[i],new f({x:r.from.x,y:r.from.y},{x:r.cp1.x,y:r.cp1.y},{x:r.cp2.x,y:r.cp2.y},{x:r.to.x,y:r.to.y})),t)}},R.prototype.divide=function(){var t=[],r=void 0,e=void 0;for(var i in this.ops){var n=this.ops[i];"move"===n.type?e=n.to:"line"===n.type?n.to.sitsRoughlyOn(r)||t.push((new R).move(r).line(n.to)):"curve"===n.type?t.push((new R).move(r).curve(n.cp1,n.cp2,n.to)):"close"===n.type&&t.push((new R).move(r).line(e)),n.to&&(r=n.to)}return t},R.prototype.intersectsX=function(t){return this.intersectsAxis(t,"x")},R.prototype.intersectsY=function(t){return this.intersectsAxis(t,"y")},R.prototype.intersectsAxis=function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0],r=arguments[1];if(!1===t)throw"Path.intersects[X-Y] requires an value as parameter";var i=[],n="x"===r?new e(t,-1e5):new e(-1e4,t),o="x"===r?new e(t,1e5):new e(1e5,t),s=!0,a=!1,h=void 0;try{for(var p,u=this.divide()[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;"line"===f.ops[1].type?C(d(f.ops[0].to,f.ops[1].to,n,o),i):"curve"===f.ops[1].type&&C(w(n,o,f.ops[0].to,f.ops[1].cp1,f.ops[1].cp2,f.ops[1].to),i)}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return i},R.prototype.intersects=function(t){if(this===t)throw"Calculating intersections between two identical paths is bad idea";var r=[],e=!0,i=!1,n=void 0;try{for(var o,s=this.divide()[Symbol.iterator]();!(e=(o=s.next()).done);e=!0){var a=o.value,h=!0,p=!1,u=void 0;try{for(var f,y=t.divide()[Symbol.iterator]();!(h=(f=y.next()).done);h=!0){var c=f.value;"line"===a.ops[1].type?"line"===c.ops[1].type?C(d(a.ops[0].to,a.ops[1].to,c.ops[0].to,c.ops[1].to),r):"curve"===c.ops[1].type&&C(w(a.ops[0].to,a.ops[1].to,c.ops[0].to,c.ops[1].cp1,c.ops[1].cp2,c.ops[1].to),r):"curve"===a.ops[1].type&&("line"===c.ops[1].type?C(w(c.ops[0].to,c.ops[1].to,a.ops[0].to,a.ops[1].cp1,a.ops[1].cp2,a.ops[1].to),r):"curve"===c.ops[1].type&&C(b(a.ops[0].to,a.ops[1].cp1,a.ops[1].cp2,a.ops[1].to,c.ops[0].to,c.ops[1].cp1,c.ops[1].cp2,c.ops[1].to),r))}}catch(t){p=!0,u=t}finally{try{!h&&y.return&&y.return()}finally{if(p)throw u}}}}catch(t){i=!0,n=t}finally{try{!e&&s.return&&s.return()}finally{if(i)throw n}}return r},R.prototype.split=function(t){var r=this.divide(),i=!1,n=!1;for(var o in r){var s=r[o];if("line"===s.ops[1].type)x(s.ops[0].to,s.ops[1].to,t)&&((i=r.slice(0,o)).push((new R).move(s.ops[0].to).line(t)),o++,(n=r.slice(o)).unshift((new R).move(t).line(s.ops[1].to)));else if("curve"===s.ops[1].type){var a=g(s.ops[0].to,s.ops[1].cp1,s.ops[1].cp2,s.ops[1].to,t);if(!1!==a){var h=new f({x:s.ops[0].to.x,y:s.ops[0].to.y},{x:s.ops[1].cp1.x,y:s.ops[1].cp1.y},{x:s.ops[1].cp2.x,y:s.ops[1].cp2.y},{x:s.ops[1].to.x,y:s.ops[1].to.y}).split(a);(i=r.slice(0,o)).push((new R).move(new e(h.left.points[0].x,h.left.points[0].y)).curve(new e(h.left.points[1].x,h.left.points[1].y),new e(h.left.points[2].x,h.left.points[2].y),new e(h.left.points[3].x,h.left.points[3].y))),o++,(n=r.slice(o)).unshift((new R).move(new e(h.right.points[0].x,h.right.points[0].y)).curve(new e(h.right.points[1].x,h.right.points[1].y),new e(h.right.points[2].x,h.right.points[2].y),new e(h.right.points[3].x,h.right.points[3].y)))}}}return i&&(i=I(i)),n&&(n=I(n)),[i,n]},R.prototype.trim=function(){var t=this.divide();for(var r in t)for(var i=parseInt(r)+2,n=parseInt(t.length)-1,o=i;o<n;o++){var s=t[r].intersects(t[o]);if(s.length>0){for(var a=s.pop(),h=t.slice(0,r),p=t.slice(parseInt(o)+1),u=new R,y=!0,c=[r,o],l=0;l<c.length;l++){var d=t[c[l]].ops;if("line"===d[1].type)u.line(a);else if("curve"===d[1].type){var v=new f({x:d[0].to.x,y:d[0].to.y},{x:d[1].cp1.x,y:d[1].cp1.y},{x:d[1].cp2.x,y:d[1].cp2.y},{x:d[1].to.x,y:d[1].to.y}),x=g(d[0].to,d[1].cp1,d[1].cp2,d[1].to,a),m=v.split(x),w=void 0;w=y?m.left:m.right,u.curve(new e(w.points[1].x,w.points[1].y),new e(w.points[2].x,w.points[2].y),new e(w.points[3].x,w.points[3].y))}y=!1}var b=void 0;return b=h.length>0?I(h).join(u):u,p.length>0&&(b=b.join(I(p))),b.trim()}}return this},R.prototype.translate=function(t,r){var e=this.clone(),i=!0,n=!1,o=void 0;try{for(var s,a=e.ops[Symbol.iterator]();!(i=(s=a.next()).done);i=!0){var h=s.value;"close"!==h.type&&(h.to=h.to.translate(t,r)),"curve"===h.type&&(h.cp1=h.cp1.translate(t,r),h.cp2=h.cp2.translate(t,r))}}catch(t){n=!0,o=t}finally{try{!i&&a.return&&a.return()}finally{if(n)throw o}}return e},E.prototype.attr=function(t,r){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,r):this.attributes.add(t,r),this},E.prototype.clone=function(){var t=new E(this.def,this.anchor.clone());return t.attributes=this.attributes.clone(),t},N.prototype.macroClosure=function(t){var r=this;return function(t,e){var i=c(t);"function"==typeof r[i]?r[i](e):r.debug("warning","🚨 Macro not found","Macro "+i.substr(7)+" is not registered")}},N.prototype.debugClosure=function(){var t=this;return function(r,e,i,n,o){t.debug(r,e,i,n,o)}},N.prototype.debug=function(t){},N.prototype.getId=function(){return this.freeId+=1,""+this.freeId},N.prototype.unitsClosure=function(t){var r=this;return function(t){return m(t,r.context.settings.units)}},N.prototype.boundary=function(){if(this.topLeft)return this;var t=new e(1/0,1/0),r=new e(-1/0,-1/0);for(var i in this.paths){var n=this.paths[i].boundary();n.render&&(n.topLeft.x<t.x&&(t.x=n.topLeft.x),n.topLeft.y<t.y&&(t.y=n.topLeft.y),n.bottomRight.x>r.x&&(r.x=n.bottomRight.x),n.bottomRight.y>r.y&&(r.y=n.bottomRight.y))}for(var o in this.points){var s=this.points[o],a=s.attributes.get("data-circle");a&&(a=parseFloat(a),s.x-a<t.x&&(t.x=s.x-a),s.y-a<t.y&&(t.y=s.y-a),s.x+a>r.x&&(r.x=s.x+a),s.y+a>r.y&&(r.y=s.y+a))}t.x===1/0&&(t.x=0),t.y===1/0&&(t.y=0),r.x===-1/0&&(r.x=0),r.y===-1/0&&(r.y=0);var h=this.context.settings.margin;return this.context.settings.paperless&&h<10&&(h=10),this.topLeft=new e(t.x-h,t.y-h),this.bottomRight=new e(r.x+h,r.y+h),this.width=this.bottomRight.x-this.topLeft.x,this.height=this.bottomRight.y-this.topLeft.y,this},N.prototype.stack=function(){return!1!==this.topLeft?this:(this.boundary(),0==this.topLeft.x&&0==this.topLeft.y?this:(this.attr("transform","translate("+-1*this.topLeft.x+", "+-1*this.topLeft.y+")"),this))},N.prototype.attr=function(t,r){return arguments.length>2&&void 0!==arguments[2]&&arguments[2]?this.attributes.set(t,r):this.attributes.add(t,r),this},N.prototype.inject=function(t){for(var r=["points","paths","snippets"],e=0;e<r.length;e++){var i=r[e];for(var n in t[i])void 0===this[i][n]&&(this[i][n]=t[i][n].clone())}return this},N.prototype.units=function(t){return m(t,this.context.settings.units)},N.prototype.shorthand=function(){var t=!!this.context.settings.complete,r=!0===this.context.settings.paperless;return{sa:this.context.settings.complete&&this.context.settings.sa||0,measurements:this.context.settings.measurements||{},options:this.context.settings.options||{},store:this.context.store,points:this.points||{},paths:this.paths||{},snippets:this.snippets||{},macro:this.macroClosure(),units:this.unitsClosure(),utils:M,Point:this.Point,Path:this.Path,Snippet:this.Snippet,complete:t,paperless:r,debug:this.debugClosure()}};var D="0.22.0";function H(t){this.openGroups=[],this.freeId=0,this.body="",this.style="",this.script="",this.header="",this.footer="",this.defs="",this.pattern=t,this.prefix='<?xml version="1.0" encoding="UTF-8" standalone="no"?>',this.attributes=new r,this.attributes.add("xmlns","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:svg","http://www.w3.org/2000/svg"),this.attributes.add("xmlns:xlink","http://www.w3.org/1999/xlink"),this.attributes.add("xml:lang",t.settings.locale),this.attributes.add("xmlns:freesewing","http://freesewing.org/namespaces/freesewing"),this.attributes.add("freesewing",D)}H.prototype.runHooks=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===r&&(r=this);var e=this.hooks[t];if(e.length>0){var i=!0,n=!1,o=void 0;try{for(var s,a=e[Symbol.iterator]();!(i=(s=a.next()).done);i=!0){var h=s.value;h.method(r,h.data)}}catch(t){n=!0,o=t}finally{try{!i&&a.return&&a.return()}finally{if(n)throw o}}}},H.prototype.insertText=function(t){if(this.hooks.insertText.length>0){var r=!0,e=!1,i=void 0;try{for(var n,o=this.hooks.insertText[Symbol.iterator]();!(r=(n=o.next()).done);r=!0){var s=n.value;t=s.method(t,s.data)}}catch(t){e=!0,i=t}finally{try{!r&&o.return&&o.return()}finally{if(e)throw i}}}return t},H.prototype.debug=function(){},H.prototype.render=function(t){for(var r in this.idPrefix=t.settings.idPrefix,this.runHooks("preRender"),t.settings.embed||(this.attributes.add("width",t.width+"mm"),this.attributes.add("height",t.height+"mm")),this.attributes.add("viewBox","0 0 "+t.width+" "+t.height),this.svg=this.prefix,this.svg+=this.renderComments(this.header),this.svg+=this.renderSvgTag(t),this.svg+=this.renderStyle(),this.svg+=this.renderScript(),this.svg+=this.renderDefs(),this.svg+=this.openGroup(this.idPrefix+"container"),t.parts){var e=t.parts[r];e.render&&t.needs(r)&&(this.svg+=this.openGroup(this.idPrefix+"part-"+r,e.attributes),this.svg+=this.renderPart(e),this.svg+=this.closeGroup())}return this.svg+=this.closeGroup(),this.svg+=this.nl()+"</svg>",this.svg+=this.renderComments(this.footer),this.runHooks("postRender"),this.svg},H.prototype.renderSvgTag=function(t){var r="<svg";return this.indent(),r+=this.nl()+this.attributes.render(),this.outdent(),r+=this.nl()+">"+this.nl()},H.prototype.renderStyle=function(){var t='<style type="text/css"> <![CDATA[ ';return this.indent(),t+=this.nl()+this.style,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"</style>"+this.nl()},H.prototype.renderScript=function(){var t='<script type="text/javascript"> <![CDATA[';return this.indent(),t+=this.nl()+this.script,this.outdent(),t+=this.nl()+"]]>"+this.nl()+"<\/script>"+this.nl()},H.prototype.renderDefs=function(){var t="<defs>";return this.indent(),t+=this.nl()+this.defs,this.outdent(),t+=this.nl()+"</defs>"+this.nl()},H.prototype.renderComments=function(t){return this.nl()+this.nl()+"\x3c!--"+this.nl()+t+this.nl()+"--\x3e"},H.prototype.renderPart=function(t){var r="";for(var e in t.paths){var i=t.paths[e];i.render&&(r+=this.renderPath(i))}for(var n in t.points)t.points[n].attributes.get("data-text")&&(r+=this.renderText(t.points[n])),t.points[n].attributes.get("data-circle")&&(r+=this.renderCircle(t.points[n]));for(var o in t.snippets){var s=t.snippets[o];r+=this.renderSnippet(s,t)}return r},H.prototype.renderPath=function(t){return t.attributes.get("id")||t.attributes.add("id",this.idPrefix+this.getId()),t.attributes.set("d",t.asPathstring()),this.nl()+"<path "+t.attributes.render()+" />"+this.renderPathText(t)},H.prototype.renderPathText=function(t){var r=t.attributes.get("data-text");if(!r)return"";this.text=this.insertText(r);var e=t.attributes.renderIfPrefixIs("data-text-"),i="",n=t.attributes.get("data-text-class");n&&n.indexOf("center")>-1?i=' startOffset="50%" ':n&&n.indexOf("right")>-1&&(i=' startOffset="100%" ');var o=this.nl()+"<text>";return this.indent(),o+='<textPath xlink:href="#'+t.attributes.get("id")+'" '+i+"><tspan "+e+">"+this.text+"</tspan></textPath>",this.outdent(),o+=this.nl()+"</text>"},H.prototype.renderText=function(t){var r=t.attributes.getAsArray("data-text");if(!1!==r){var e="",i=!0,n=!1,o=void 0;try{for(var s,a=r[Symbol.iterator]();!(i=(s=a.next()).done);i=!0){var h=s.value;this.text=this.insertText(h),e+=this.text+" "}}catch(t){n=!0,o=t}finally{try{!i&&a.return&&a.return()}finally{if(n)throw o}}this.text=this.insertText(e)}t.attributes.set("data-text-x",t.x),t.attributes.set("data-text-y",t.y);var p=t.attributes.get("data-text-lineheight")||12;t.attributes.remove("data-text-lineheight");var u=this.nl()+"<text "+t.attributes.renderIfPrefixIs("data-text-")+">";if(this.indent(),-1!==this.text.indexOf("\n")){var f=this.text.split("\n");u+="<tspan>"+f.shift()+"</tspan>";var y=!0,c=!1,l=void 0;try{for(var d,v=f[Symbol.iterator]();!(y=(d=v.next()).done);y=!0){var x=d.value;u+='<tspan x="'+t.x+'" dy="'+p+'">'+x+"</tspan>"}}catch(t){c=!0,l=t}finally{try{!y&&v.return&&v.return()}finally{if(c)throw l}}}else u+="<tspan>"+this.text+"</tspan>";return this.outdent(),u+=this.nl()+"</text>"},H.prototype.renderCircle=function(t){return'<circle\n    cx="'+t.x+'"\n    cy="'+t.y+'"\n    r="'+t.attributes.get("data-circle")+'"\n    '+t.attributes.renderIfPrefixIs("data-circle-")+"\n  ></circle>"},H.prototype.renderSnippet=function(t,r){var e=t.anchor.x,i=t.anchor.y,n=t.attributes.get("data-scale");n&&(t.attributes.add("transform","translate("+e+", "+i+")"),t.attributes.add("transform","scale("+n+")"),t.attributes.add("transform","translate("+-1*e+", "+-1*i+")"));var o=t.attributes.get("data-rotate");o&&t.attributes.add("transform","rotate("+o+", "+e+", "+i+")");var s=this.nl();return s+='<use x="'+e+'" y="'+i+'" ',s+='xlink:href="#'+t.def+'" '+t.attributes.render()+">",s+="</use>"},H.prototype.openGroup=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1],e=this.nl()+this.nl();return e+="\x3c!-- Start of group #"+t+" --\x3e",e+=this.nl(),e+='<g id="'+t+'"',r&&(e+=" "+r.render()),e+=">",this.indent(),this.openGroups.push(t),e},H.prototype.closeGroup=function(){return this.outdent(),this.nl()+"</g>"+this.nl()+"\x3c!-- end of group #"+this.openGroups.pop()+" --\x3e"},H.prototype.nl=function(){return"\n"+this.tab()},H.prototype.tab=function(){for(var t="",r=0;r<this.tabs;r++)t+="  ";return t},H.prototype.indent=function(){this.tabs+=1},H.prototype.outdent=function(){this.tabs-=1},H.prototype.getId=function(){return this.freeId+=1,""+this.freeId};var F=function(){};F.prototype={fit:function(t){var r,e,i,n,o=t.length,s=o>0?t[0].width:0,a=o>0?t[0].height:0;for(this.root={x:0,y:0,width:s,height:a},r=0;r<o;r++)i=t[r],(e=this.findNode(this.root,i.width,i.height))?(n=this.splitNode(e,i.width,i.height),i.x=n.x,i.y=n.y):(n=this.growNode(i.width,i.height),i.x=n.x,i.y=n.y)},findNode:function(t,r,e){return t.used?this.findNode(t.right,r,e)||this.findNode(t.down,r,e):r<=t.width&&e<=t.height?t:null},splitNode:function(t,r,e){return t.used=!0,t.down={x:t.x,y:t.y+e,width:t.width,height:t.height-e},t.right={x:t.x+r,y:t.y,width:t.width-r,height:e},t},growNode:function(t,r){var e=t<=this.root.width,i=r<=this.root.height,n=i&&this.root.height>=this.root.width+t,o=e&&this.root.width>=this.root.height+r;return n?this.growRight(t,r):o?this.growDown(t,r):i?this.growRight(t,r):e?this.growDown(t,r):null},growRight:function(t,r){var e;return this.root={used:!0,x:0,y:0,width:this.root.width+t,height:this.root.height,down:this.root,right:{x:this.root.width,y:0,width:t,height:this.root.height}},(e=this.findNode(this.root,t,r))?this.splitNode(e,t,r):null},growDown:function(t,r){var e;return this.root={used:!0,x:0,y:0,width:this.root.width,height:this.root.height+r,down:{x:0,y:this.root.height,width:this.root.width,height:r},right:this.root},(e=this.findNode(this.root,t,r))?this.splitNode(e,t,r):null}};var G=F;function q(){this.data=new Map}q.prototype.set=function(t,r){this.data.set(t,r)},q.prototype.setIfUnset=function(t,r){this.data.has(t)||this.data.set(t,r)},q.prototype.get=function(t){return this.data.get(t)};var U={preDraft:[],postDraft:[],preSample:[],postSample:[],preRender:[],postRender:[],insertText:[],debug:[]};function B(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];for(var r in this.config=t||{},this.width=!1,this.height=!1,this.is="",this.store=new q,this.parts={},this.hooks=U,this.Part=N,this.Point=e,this.Path=R,this.Snippet=E,this.settings={complete:!0,idPrefix:"fs-",locale:"en",units:"metric",margin:2,options:{}},void 0===this.config.inject&&(this.config.inject=[]),void 0===this.config.dependencies&&(this.config.dependencies={}),void 0===this.config.hide&&(this.config.hide=[]),this.config.resolvedDependencies=this.resolveDependencies(this.config.dependencies),this.config.draftOrder=this.draftOrder(this.config.resolvedDependencies),t.options){var i=t.options[r];if("object"===(void 0===i?"undefined":k(i)))if(void 0!==i.pct)this.settings.options[r]=i.pct/100;else if(void 0!==i.mm)this.settings.options[r]=i.mm;else if(void 0!==i.deg)this.settings.options[r]=i.deg;else if(void 0!==i.count)this.settings.options[r]=i.count;else{if(void 0===i.dflt)throw"Unknown option type";this.settings.options[r]=i.dflt}else this.settings.options[r]=i}this.context={parts:this.parts,config:this.config,settings:this.settings,store:this.store}}return B.prototype.createPart=function(){var t=new N;return t.context=this.context,t},B.prototype.mergeSettings=function(t){var r=!0,e=!1,i=void 0;try{for(var n,o=Object.keys(t)[Symbol.iterator]();!(r=(n=o.next()).done);r=!0){var s=n.value;"object"===k(t[s])?this.settings[s]=P({},this.settings[s],t[s]):this.settings[s]=t[s]}}catch(t){e=!0,i=t}finally{try{!r&&o.return&&o.return()}finally{if(e)throw i}}},B.prototype.runHooks=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];!1===r&&(r=this);var e=this.hooks[t];if(e.length>0){var i=!0,n=!1,o=void 0;try{for(var s,a=e[Symbol.iterator]();!(i=(s=a.next()).done);i=!0){var h=s.value;h.method(r,h.data)}}catch(t){n=!0,o=t}finally{try{!i&&a.return&&a.return()}finally{if(n)throw o}}}},B.prototype.draft=function(){this.is="draft",this.runHooks("preDraft");var t=!0,r=!1,e=void 0;try{for(var i,n=this.config.draftOrder[Symbol.iterator]();!(t=(i=n.next()).done);t=!0){var o=i.value,s=this.createPart();if("string"==typeof this.config.inject[o]&&s.inject(this.parts[this.config.inject[o]]),this.needs(o)){var a="draft"+y(o);if("function"!=typeof this[a])throw new Error('Method "'+a+'" on pattern object is not callable');this.parts[o]=this[a](s),this.parts[o].render=this.wants(o)}}}catch(t){r=!0,e=t}finally{try{!t&&n.return&&n.return()}finally{if(r)throw e}}return this.runHooks("postDraft"),this},B.prototype.sample=function(){return"option"===this.settings.sample.type?this.sampleOption(this.settings.sample.option):"measurement"===this.settings.sample.type?this.sampleMeasurement(this.settings.sample.measurement):"models"===this.settings.sample.type?this.sampleModels(this.settings.sample.models,this.settings.sample.focus||!1):void 0},B.prototype.sampleParts=function(){var t={};for(var r in this.settings.complete=!1,this.settings.paperless=!1,this.draft(),this.parts)t[r]=this.createPart(),t[r].render=this.parts[r].render;return t},B.prototype.sampleRun=function(t,r,e,i){var n=arguments.length>4&&void 0!==arguments[4]&&arguments[4];for(var o in this.draft(),this.parts){var s=0,a=0;for(var h in this.parts[o].points.anchor&&(void 0===r[o]?r[o]=this.parts[o].points.anchor:r[o].sitsOn(this.parts[o].points.anchor)||(s=this.parts[o].points.anchor.dx(r[o]),a=this.parts[o].points.anchor.dy(r[o]))),this.parts[o].paths)t[o].paths[h+"_"+e]=this.parts[o].paths[h].clone().attr("style",_(e,i)),this.parts[o].points.anchor&&(t[o].paths[h+"_"+e]=t[o].paths[h+"_"+e].translate(s,a)),!1!==n&&t[o].paths[h+"_"+e].attributes.add("class",n)}},B.prototype.sampleOption=function(t){this.is="sample",this.runHooks("preSample");var r,e=void 0,i=1,n={},o=this.sampleParts(),s=this.config.options[t];if("object"===k(s.list))return this.sampleListOption(t);void 0!==s.min&&void 0!==s.max||(s={min:.9*s,max:1.1*s});void 0!==s.pct&&(i=100),e=s.min/i,r=(s.max/i-e)/9;for(var a=1;a<11;a++)this.settings.options[t]=e,this.debug("info","🏃🏿‍♀️ Sample run","Sampling option "+t+" with value "+O(e)),this.sampleRun(o,n,a,10),e+=r;return this.parts=o,this.runHooks("postSample"),this},B.prototype.sampleListOption=function(t){var r=this.sampleParts(),e=this.config.options[t],i={},n=1,o=e.list.length,s=!0,a=!1,h=void 0;try{for(var p,u=e.list[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;this.settings.options[t]=f,this.debug("info","🏃🏿‍♀️ Sample run","Sampling option "+t+" with value "+O(f)),this.sampleRun(r,i,n,o),n++}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}return this.parts=r,this},B.prototype.sampleMeasurement=function(t){this.is="sample",this.runHooks("preSample");var r={},e=this.sampleParts(),i=this.settings.measurements[t];if(void 0===i)throw"Cannot sample a measurement that is undefined";var n=i/50;i*=.9;for(var o=1;o<11;o++)this.settings.measurements[t]=i,this.debug("info","🏃🏿‍♀️ Sample run","Sampling measurement "+t+" with value "+O(i)),this.sampleRun(e,r,o,10),i+=n;return this.parts=e,this.runHooks("postSample"),this},B.prototype.sampleModels=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this.is="sample",this.runHooks("preSample");var e={},i=this.sampleParts(),n=0,o=Object.keys(t).length;for(var s in t){n++,this.settings.measurements=t[s],this.debug("info","🏃🏿‍♀️ Sample run","Sampling model "+s);var a=s===r?"sample-focus":"";this.sampleRun(i,e,n,o,a)}return this.parts=i,this.runHooks("postSample"),this},B.prototype.debug=function(){for(var t=arguments.length,r=Array(t),e=0;e<t;e++)r[e]=arguments[e];this.runHooks("debug",r)},B.prototype.render=function(){return this.svg=new H(this),this.svg.hooks=this.hooks,this.pack().svg.render(this)},B.prototype.on=function(t,r,e){this.hooks[t].push({method:r,data:e})},B.prototype.with=function(t){var r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];return this.debug("success","🔌 Plugin loaded",t.name+" v"+t.version),t.hooks&&this.loadPluginHooks(t,r),t.macros&&this.loadPluginMacros(t),this},B.prototype.loadPluginHooks=function(t,r){var e=!0,i=!1,n=void 0;try{for(var o,s=Object.keys(this.hooks)[Symbol.iterator]();!(e=(o=s.next()).done);e=!0){var a=o.value;if("function"==typeof t.hooks[a])this.on(a,t.hooks[a],r);else if("object"===k(t.hooks[a])){var h=!0,p=!1,u=void 0;try{for(var f,y=t.hooks[a][Symbol.iterator]();!(h=(f=y.next()).done);h=!0){var c=f.value;this.on(a,c,r)}}catch(t){p=!0,u=t}finally{try{!h&&y.return&&y.return()}finally{if(p)throw u}}}}}catch(t){i=!0,n=t}finally{try{!e&&s.return&&s.return()}finally{if(i)throw n}}},B.prototype.loadPluginMacros=function(t){for(var r in t.macros)"function"==typeof t.macros[r]&&this.macro(r,t.macros[r])},B.prototype.macro=function(t,r){this.Part.prototype[c(t)]=r},B.prototype.pack=function(){var t=[];for(var r in this.parts){var e=this.parts[r];e.attributes.set("transform",""),e.render&&this.needs(r)&&(e.stack(),t.push({id:r,width:e.bottomRight.x-e.topLeft.x,height:e.bottomRight.y-e.topLeft.y}))}var i=function(t,r){r=r||{};var e=new G,i=r.inPlace||!1,n=t.map(function(t){return i?t:{width:t.width,height:t.height,item:t}});n=n.sort(function(t,r){return r.width*r.height-t.width*t.height}),e.fit(n);var o={width:n.reduce(function(t,r){return Math.max(t,r.x+r.width)},0),height:n.reduce(function(t,r){return Math.max(t,r.y+r.height)},0)};return i||(o.items=n),o}(t,{inPlace:!0}),n=!0,o=!1,s=void 0;try{for(var a,h=t[Symbol.iterator]();!(n=(a=h.next()).done);n=!0){var p=a.value,u=this.parts[p.id];0===p.x&&0===p.y||u.attr("transform","translate ("+p.x+", "+p.y+")")}}catch(t){o=!0,s=t}finally{try{!n&&h.return&&h.return()}finally{if(o)throw s}}return this.width=i.width,this.height=i.height,this},B.prototype.draftOrder=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.resolveDependencies(),r=[],e={};return Object.keys(t).forEach(function i(n,o){Array.isArray(o)||(o=[]),o.push(n),e[n]=!0,void 0!==t[n]&&t[n].forEach(function(t){if(o.indexOf(t)>=0)throw new Error('Circular dependency "'+t+'" is required by "'+n+'": '+o.join(" -> "));e[t]||i(t,o.slice(0))}),r.indexOf(n)<0&&r.push(n)}),r},B.prototype.resolveDependency=function(t,r){var e=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.config.dependencies,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:[];return void 0===t[r]&&(t[r]=!0),"string"==typeof e[r]?(i.push(e[r]),this.resolveDependency(t,e[r],e,i)):i},B.prototype.resolveDependencies=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.config.dependencies,r={},e={},i=!0,n=!1,o=void 0;try{for(var s,a=Object.keys(t)[Symbol.iterator]();!(i=(s=a.next()).done);i=!0){var h=s.value;r[h]=this.resolveDependency(e,h,t)}}catch(t){n=!0,o=t}finally{try{!i&&a.return&&a.return()}finally{if(n)throw o}}var p=!0,u=!1,f=void 0;try{for(var y,c=Object.keys(e)[Symbol.iterator]();!(p=(y=c.next()).done);p=!0){var l=y.value;void 0===r[l]&&(r[l]=[])}}catch(t){u=!0,f=t}finally{try{!p&&c.return&&c.return()}finally{if(u)throw f}}return r},B.prototype.needs=function(t){if(void 0===this.settings.only)return!0;if("string"==typeof this.settings.only){if(this.settings.only===t)return!0;if(Array.isArray(this.config.resolvedDependencies[this.settings.only])){var r=!0,e=!1,i=void 0;try{for(var n,o=this.config.resolvedDependencies[this.settings.only][Symbol.iterator]();!(r=(n=o.next()).done);r=!0){if(n.value===t)return!0}}catch(t){e=!0,i=t}finally{try{!r&&o.return&&o.return()}finally{if(e)throw i}}}}else if(Array.isArray(this.settings.only)){var s=!0,a=!1,h=void 0;try{for(var p,u=this.settings.only[Symbol.iterator]();!(s=(p=u.next()).done);s=!0){var f=p.value;if(f===t)return!0;var y=!0,c=!1,l=void 0;try{for(var d,v=this.config.resolvedDependencies[f][Symbol.iterator]();!(y=(d=v.next()).done);y=!0){if(d.value===t)return!0}}catch(t){c=!0,l=t}finally{try{!y&&v.return&&v.return()}finally{if(c)throw l}}}}catch(t){a=!0,h=t}finally{try{!s&&u.return&&u.return()}finally{if(a)throw h}}}return!1},B.prototype.isHidden=function(t){return!(!Array.isArray(this.config.hide)||-1===this.config.hide.indexOf(t))},B.prototype.wants=function(t){if(void 0===this.settings.only){if(this.isHidden(t))return!1}else{if("string"==typeof this.settings.only)return this.settings.only===t;if(Array.isArray(this.settings.only)){var r=!0,e=!1,i=void 0;try{for(var n,o=this.settings.only[Symbol.iterator]();!(r=(n=o.next()).done);r=!0){if(n.value===t)return!0}}catch(t){e=!0,i=t}finally{try{!r&&o.return&&o.return()}finally{if(e)throw i}}return!1}}return!0},{version:D,Pattern:B,Point:e,Path:R,Snippet:E,utils:M,patterns:{},plugins:{}}}(crypto);
//# sourceMappingURL=browser.js.map
